
-----------------------------------------------------------------------------------------------
-- Client Lua Script for Slashlist
-- Copyright (c) NCsoft. All rights reserved
-----------------------------------------------------------------------------------------------
 
require "Window"
require "ChatSystemLib"
 
-----------------------------------------------------------------------------------------------
-- Slashlist Module Definition
-----------------------------------------------------------------------------------------------
local Slashlist = {} 
 
-----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
-- e.g. local kiExampleVariableMax = 999
 
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function Slashlist:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    -- initialize variables here

    return o
end

function Slashlist:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		-- "UnitOrPackageName",
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end
 

-----------------------------------------------------------------------------------------------
-- Slashlist OnLoad
-----------------------------------------------------------------------------------------------
function Slashlist:OnLoad()
    -- load our form file
	self.xmlDoc = XmlDoc.CreateFromFile("Slashlist.xml")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
	local AddMod = ChatSystemLib.ChatChannelAction_AddModerator
	
end

-----------------------------------------------------------------------------------------------
-- Slashlist OnDocLoaded
-----------------------------------------------------------------------------------------------
function Slashlist:OnDocLoaded()

	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
	    self.wndMain = Apollo.LoadForm(self.xmlDoc, "SlashlistForm", nil, self)
		if self.wndMain == nil then
			Apollo.AddAddonErrorText(self, "Could not load the main window for some reason.")
			return
		end
		
	    self.wndMain:Show(false, true)

		-- if the xmlDoc is no longer needed, you should set it to nil
		-- self.xmlDoc = nil
		
		-- Register handlers for events, slash commands and timer, etc.
		-- e.g. Apollo.RegisterEventHandler("KeyDown", "OnKeyDown", self)
		Apollo.RegisterSlashCommand("slashlist", "OnSlashlistOn", self)

		self.timer = ApolloTimer.Create(1.0, true, "OnTimer", self)

		-- Do additional Addon initialization here
	end
end

-----------------------------------------------------------------------------------------------
-- Slashlist Functions
-----------------------------------------------------------------------------------------------
-- Define general functions here

-- on SlashCommand "/slashlist"
function Slashlist:OnSlashlistOn()
	local strTextColor = "UI_TextHoloBodyHighlight"
	local chatcmds = ChatSystemLib.GetCommands()
	local chatchans = ChatSystemLib.GetChannels()	
	local wndGrid = self.wndMain:FindChild("chatgrid")
	wndGrid:DeleteAll()
	for key, value in pairs(chatcmds) do
		local iCurrRow = wndGrid:AddRow("")
		wndGrid:SetCellDoc(iCurrRow, 1, "<T Font=\"CRB_InterfaceSmall\" TextColor=\""..strTextColor.."\">".. value .."</T>")
	end	
	self.wndMain:Invoke() -- show the window
end

-- on timer
function Slashlist:OnTimer()
	-- Do your timer-related stuff here.
end


-----------------------------------------------------------------------------------------------
-- SlashlistForm Functions
-----------------------------------------------------------------------------------------------
-- when the OK button is clicked
function Slashlist:OnOK()
	self.wndMain:Close() -- hide the window
end

-- when the Cancel button is clicked
function Slashlist:OnCancel()
	self.wndMain:Close() -- hide the window
end


-----------------------------------------------------------------------------------------------
-- Slashlist Instance
-----------------------------------------------------------------------------------------------
local SlashlistInst = Slashlist:new()
SlashlistInst:Init()
